package xyz.lychee.lagfixer.libs.adventure.translation;

import java.util.Locale;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.renderer.TranslatableComponentRenderer;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.ScheduledForRemoval;
import xyz.lychee.lagfixer.libs.examination.Examinable;

public interface GlobalTranslator extends Translator, Examinable {
   static @NotNull GlobalTranslator translator() {
      return GlobalTranslatorImpl.INSTANCE;
   }

   /** @deprecated */
   @Deprecated
   @ScheduledForRemoval(
      inVersion = "5.0.0"
   )
   static @NotNull GlobalTranslator get() {
      return GlobalTranslatorImpl.INSTANCE;
   }

   static @NotNull TranslatableComponentRenderer<Locale> renderer() {
      return GlobalTranslatorImpl.INSTANCE.renderer;
   }

   static @NotNull Component render(final @NotNull Component component, final @NotNull Locale locale) {
      return renderer().render(component, locale);
   }

   @NotNull Iterable<? extends Translator> sources();

   boolean addSource(final @NotNull Translator source);

   boolean removeSource(final @NotNull Translator source);
}
